/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.records.TCoreLastchangeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLastchange extends TableImpl<TCoreLastchangeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_lastchange</code>
     */
    public static final TCoreLastchange T_CORE_LASTCHANGE = new TCoreLastchange();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLastchangeRecord> getRecordType() {
        return TCoreLastchangeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_lastchange.lastchange</code>.
     */
    public final TableField<TCoreLastchangeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_lastchange.schemaname</code>.
     */
    public final TableField<TCoreLastchangeRecord, String> SCHEMANAME = createField(DSL.name("schemaname"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_lastchange.tablename</code>.
     */
    public final TableField<TCoreLastchangeRecord, String> TABLENAME = createField(DSL.name("tablename"), SQLDataType.CLOB.nullable(false), this, "");

    private TCoreLastchange(Name alias, Table<TCoreLastchangeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLastchange(Name alias, Table<TCoreLastchangeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_lastchange</code> table
     * reference
     */
    public TCoreLastchange(String alias) {
        this(DSL.name(alias), T_CORE_LASTCHANGE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_lastchange</code> table
     * reference
     */
    public TCoreLastchange(Name alias) {
        this(alias, T_CORE_LASTCHANGE);
    }

    /**
     * Create a <code>common_dd.t_core_lastchange</code> table reference
     */
    public TCoreLastchange() {
        this(DSL.name("t_core_lastchange"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<UniqueKey<TCoreLastchangeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_LASTCHANGE);
    }

    @Override
    public TCoreLastchange as(String alias) {
        return new TCoreLastchange(DSL.name(alias), this);
    }

    @Override
    public TCoreLastchange as(Name alias) {
        return new TCoreLastchange(alias, this);
    }

    @Override
    public TCoreLastchange as(Table<?> alias) {
        return new TCoreLastchange(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLastchange rename(String name) {
        return new TCoreLastchange(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLastchange rename(Name name) {
        return new TCoreLastchange(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLastchange rename(Table<?> name) {
        return new TCoreLastchange(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLastchange where(Condition condition) {
        return new TCoreLastchange(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLastchange where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLastchange where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLastchange where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLastchange where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLastchange where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLastchange where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLastchange where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLastchange whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLastchange whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
